/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Timer0.H
**     Project   : voltmeter_led
**     Processor : MC56F8006_48_LQFP
**     Beantype  : Init_TMR
**     Version   : Bean 01.131, Driver 02.01, CPU db: 3.00.177
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 11/12/2008, 9:18 AM
**     Abstract  :
**         This "Init_TMR" Peripheral Inspector implements the
**         Quad Timer module (TMR), basic initialization
**         and settings.
**     Settings  :
**         Timer counter device        : TMR0
**
**         Operation mode              : Count mode
**         Count once                  : count repeatedly
**         Count length                : count till compare, then reinitialize
**         Count direction             : up
**         Master mode                 : Disabled
**         External OFLAG force        : Disabled
**         Forced OFLAG value          : 0
**         Force OFLAG ouput           : yes
**         Output enable               : no
**         Output polarity             : true
**         Input  polarity             : true
**         Co-channel init.            : Disabled
**
**         Primary source              : prescaler (IP BUS clock / 128)
**         Secondary source            : counter 0 input pin
**
**         Input capture mode          : Disabled
**
**         Output mode                 : toggle OFLAG output on successful compare
**
**         Compare load control 1      : Disabled
**         Compare load control 2      : Disabled
**
**         Debug mode action           : Normal operation
**
**         Fault                       : Disabled
**
**         Alternative load            : Disabled
**
**         Interrupts
**             Timer compare           : Enabled
**             Timer overflow          : Disabled
**             Input edge              : Disabled
**             Timer compare 1         : Disabled
**             Timer compare 2         : Disabled
**             ISR name                : Timer0ISR
**             Interrupt name          : INT_TMR0
**             Priority                : 0
**     Contents  :
**         Init - void Timer0_Init(void);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __Timer0
#define __Timer0

/* MODULE Timer0. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Cpu.h"

/* PESL device mapping  */
#define Timer0_DEVICE TMR0

extern void Timer0ISR(void);


void Timer0_Init(void);
/*
** ===================================================================
**     Method      :  Timer0_Init (bean Init_TMR)
**
**     Description :
**         This method initializes registers of the TMR module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END Timer0. */

#endif /* ifndef __Timer0 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
